<?php
// +----------------------------------------------------------------------
// | 微信公众号 发送模板消息
// +----------------------------------------------------------------------
// | Copyright (c) 2016 http://www.lrfun.com All rights reserved.
// +----------------------------------------------------------------------
// | Author: lrfun <admin@lrfun.com>
// +----------------------------------------------------------------------

Class WeChatSendMsg{
	protected $appid;
    protected $secrect;
    protected $accessToken;
	
	function __construct(){
		$this->appid       = "xxx";
		$this->secrect     = "xxx";
		$this->accessToken = $this->getAccessToken();
	}
	
	/***
	 * 获取access_token
	 * @return
	 **/
	private function getAccessToken(){
		$url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=".$this->appid."&secret=".$this->secrect;
		$res = json_decode($this->httpRequest($url),true);
		//$access_token = $res['access_token'];
		return $res['access_token'];
	}
	
	/***
	 * POST或GET请求
	 * @url 请求url
	 * @data POST数据
	 * @return
	 **/
	private function httpRequest($url, $data = ""){
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
		if(!empty($data)){	//判断是否为POST请求
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
		}
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$output = curl_exec($curl);
		curl_close($curl);
		return $output;
	}
	
	public function sendTemplateMessage($data = ""){
		$url = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=".$this->accessToken;
		$result = $this->httpRequest($url, $data);
		echo $result;
	}
}